#include "bouncing_ball.h"

using namespace std;
using namespace get_started;

void bouncing_ball::init(){
    ball.reset(new abmt::point3d);
    out_scene.points.push_back(ball);
    ball->pos.y = in_initial_height;
    ball->size = 0.5;
    ball->color = {255,0,0,255};
}

void bouncing_ball::tick(){
    double dt = 0.01;
    
    ball->pos.y += out_vy * dt + 1/2.0*g*dt*dt;
    out_vy += g*dt;
    
    if(ball->pos.y <= 0.0 && out_vy < 0){
        out_vy = -1 * out_vy * in_e;
    }
    
    out_y  = ball->pos.y;
    out_energy = -1 * g * out_y + 0.5 * out_vy * out_vy;
    if(out_energy < 0.001){
        ball->pos.y = in_initial_height;
        out_vy = 0;
    }
}