#ifndef IO_NODES_GPIO_H
#define IO_NODES_GPIO_H IO_NODES_GPIO_H

#include <cstddef>
#include <string>
#include <abmt/util/pimpl.h>

namespace io{

// Good howto for chardev gpio: https://blog.lxsang.me/post/id/33

//@node: auto
struct gpio_output{
    std::string param_device = "/dev/gpiochip0";
    unsigned int param_pin = 0;
    
    bool in;
    
    abmt::util::pimpl data;
    
    void init();
    void tick();
    void final();
    
    ~gpio_output();
};

//@node: auto
struct gpio_input{
    std::string param_device = "/dev/gpiochip0";
    unsigned int param_pin = 0;
    
    bool out;
    
    abmt::util::pimpl data;
    
    void init();
    void tick();
    void final();
    
    ~gpio_input();
};

//@node: auto
//@raster: auto
struct gpio_soft_pwm{
    double in;
    bool out;
    
    size_t param_steps = 10;

    
    void tick();
};

} // namespace io

#endif // IO_NODES_GPIO_H
