#ifndef IO_NODES_I2C_H
#define IO_NODES_I2C_H IO_NODES_I2C_H
#include <string>
#include <memory>
#include <set>
#include <type_traits>
#include <abmt/mutex.h>
#include <abmt/io/i2c.h>


namespace io{

struct i2c_bus_linux: public abmt::io::i2c_bus{
    int fd;
    std::string device;
    abmt::mutex mutex;
    std::set<int> unknown_ids;
    
    i2c_bus_linux(std::string device);
    virtual bool write_read(uint16_t addr, void* write, uint16_t w_len, void* read, uint16_t r_len);
    virtual ~i2c_bus_linux();
};

//@node: auto
struct i2c{
	abmt::io::i2c_bus_ptr out_i2c_bus;
    std::string param_device = "/dev/i2c-1";
    void init();
};

} // namespace io

#endif // IO_NODES_I2C_H
