#ifndef IO_NODES_NET_H
#define IO_NODES_NET_H IO_NODES_NET_H

#include <string>
#include <cstdint>
#include <abmt/blob.h>
#include <abmt/io/eio.h>

namespace io{

//@node: auto
struct udp_snd{
    std::string in;
    std::string param_target = "localhost";
    uint16_t param_port = 12345;
    
    abmt::io::event_list lst;
    abmt::io::udp_ptr con;
    
    void init();
    void tick();
};

//@node: auto
//@raster: source
struct udp_rcv{
    std::string out;
    std::string param_target = "any";
    uint16_t param_port = 12345;
    
    abmt::io::event_list lst;
    abmt::io::udp_ptr con;
    
    void init();
    bool poll();
};



//@node: auto
//you can also test with "$ nc localhost 12345"
struct tcp_server{
    std::string in_snd_to_all;
    std::string out;
    std::string param_target = "localhost";
    uint16_t param_port = 12345;
    
    abmt::io::event_list lst;
    abmt::io::tcp_server_ptr server;
    std::vector<abmt::io::tcp_ptr> connections;
    
    void init();
    void tick();
};

//@node: auto
struct tcp_client{
    std::string in;
    std::string out;
    std::string param_target = "localhost";
    uint16_t param_port = 12345;
    
    abmt::io::event_list lst;
    abmt::io::tcp_ptr con;
    void init();
    void tick();
};


} // namespace io

#endif // IO_NODES_NET_H
