#ifndef IO_NODES_WEBCAM_H
#define IO_NODES_WEBCAM_H IO_NODES_WEBCAM_H

#include <linux/videodev2.h>
#include <string>
#include <abmt/img.h>

namespace io{


//@node:auto
//@raster:source
class webcam{
public:
	abmt::img out_img;
	std::string param_device = "/dev/video0";
	bool param_fmt_jpeg = true; // else yuyv
	int  param_width = 640;
	int  param_height = 480;
	bool param_half_framerate = false;
	
	int  fd;
	bool init_ok = false;
	v4l2_capability     device_capabilities;
	v4l2_requestbuffers buf_request;

	struct v4l_pair{
		v4l2_buffer cfg;
		void* data;
	};
	
	v4l_pair buffers[3];
	size_t   num_buffers = 3;

	webcam();
	bool io_helper(const char* cmd_name, int cmd, void* data);
	bool open();
	bool get_device_capabilities();
	bool set_format();
	bool reqest_buffers();
	bool setup_buffer();
	bool setup_buffer(v4l2_buffer* buff, void** data, int idx);
	bool activate_streaming();
	bool queue_buff(size_t idx);
	bool poll();
	void stop_stream();
	~webcam();
};



} // namespace io

#endif // IO_NODES_WEBCAM_H
