#ifndef MATH_NODES_MATH_BASE_NODES_H
#define MATH_NODES_MATH_BASE_NODES_H MATH_NODES_MATH_BASE_NODES_H
#include <cmath>

namespace std {
    
/**
 * @node:   function;
 * @input:  ang; type: double; default: 0;
 * @output: sin; type: double;
 * @tick:   sin(ang) -> sin;
 */

/**
 * @node:   function;
 * @input:  ang; type: double; default: 0;
 * @output: cos; type: double;
 * @tick:   cos(ang) -> cos;
 */

/**
 * @node:   function;
 * @input:  ang; type: double; default: 0;
 * @output: tan; type: double;
 * @tick:   tan(ang) -> tan;
 */

/**
 * @node:   function;
 * @input:  in; type: double; default: 0;
 * @output: ang; type: double;
 * @tick:   asin(in) -> ang;
 */

/**
 * @node:   function;
 * @input:  in; type: double; default: 0;
 * @output: ang; type: double;
 * @tick:   acos(in) -> ang;
 */

/**
 * @node:   function;
 * @input:  in; type: double; default: 0;
 * @output: ang; type: double;
 * @tick:   atan(in) -> ang;
 */

/**
 * @node:   function;
 * @input:  x; type: double; default: 0;
 * @input:  y; type: double; default: 0;
 * @output: atan2; type: double;
 * @tick:   atan2(x, y) -> atan2;
 */

/**
 * @node:   function;
 * @input:  in; type: double; default: 0;
 * @output: abs; type: double;
 * @tick:   abs(in) -> abs;
 */
 
/**
 * @node:  function;
 * @input:  in; type: double; default: 0;
 * @output: sqrt; type: double;
 * @tick:   sqrt(in) -> sqrt;
 */

/**
 * @node:  function;
 * @input:  base; type: double; default: 0;
 * @input:  exponent; type: double; default: 0;
 * @output: pow; type: double;
 * @tick:   pow(base, exponent) -> pow;
 */
 
 /**
 * @node:  function;
 * @input:  in; type: double; default: 0;
 * @output: round; type: double;
 * @tick:   round(in) -> round;
 */
 
} // namespace std

#endif // MATH_NODES_MATH_BASE_NODES_H
