#ifndef RECORD_PLAYBACK_CSV_TO_JSON_H
#define RECORD_PLAYBACK_CSV_TO_JSON_H RECORD_PLAYBACK_CSV_TO_JSON_H

#include <abmt/json.h>
#include <abmt/time.h>
#include <string>
#include <vector>

namespace record_playback{

//@node:auto
struct csv_to_json{
    abmt::json out;
    
    std::string param_filename = "#h#m#s_record.csv";
    std::string param_dir = "../rec/#Y#M#D/";
    bool param_start_now = false;
    bool param_one_line_per_tick = false; // ignore time
    
    std::vector<std::string> keys;
    std::vector<std::string> lines;
    
    abmt::time next_line_time;
    abmt::time start_time = 0;
    abmt::time offset = 0;
    size_t pos = 0;
    size_t last_pos = 0;
    
    
    void init();
    void tick();    
};


} // namespace record_playback

#endif // RECORD_PLAYBACK_CSV_TO_JSON_H
