#include "json_to_csv.h"

#include <abmt/os.h>
#include <abmt/util/str_utils.h>
#include <sstream>
#include <filesystem>

using namespace std;
using namespace record_playback;

void json_to_csv::init(){
    auto start_time = get_global_start_time();
    auto dir = abmt::util::str_replace_date(param_dir, start_time);
    std::filesystem::create_directories(dir);
    auto file_name = abmt::util::str_replace_date(param_filename, start_time);
    auto path = dir + "/" + file_name;
    file = fopen(path.c_str(), "wb");
    abmt::os::die_if(file == 0, "json_to_csv: unable to open " + param_dir + "/" + param_filename);
    abmt::os::die_if(in.is_object() == false, "json_to_csv: input is not an object");
    abmt::os::log("create: " + path); // copy and paste me
    stringstream sstr;
    bool first = true;
    if(param_add_time){
        first = false;
        sstr << "Time";
    }
    for(auto i: in){
        if(first){
            first = false;
        }else{
            sstr << ",";
        }
        sstr << i.key;
        keys.push_back(i.key);
    }
    sstr << endl;
    auto str = sstr.str();
    fwrite(str.c_str(),1,str.size(),(FILE*)file);
}

void json_to_csv::tick(){
    stringstream sstr;
    bool first = true;
    if(param_add_time){
        first = false;
        sstr << abmt::util::str_replace_date();
    }
    for(auto k: keys){
        if(first){
            first = false;
        }else{
            sstr << ",";
        }
        sstr << in[k];
    }
    sstr << endl;
    auto str = sstr.str();
    fwrite(str.c_str(),1,str.size(),(FILE*)file);
}

void json_to_csv::final(){
    fclose((FILE*)file);
}