#ifndef MATH3D_EXAMPLE_BASIC_3D_H
#define MATH3D_EXAMPLE_BASIC_3D_H MATH3D_EXAMPLE_BASIC_3D_H

#include <abmt/3d.h>
#include <iostream>
namespace scene3d{

//@node: auto
struct move{
    abmt::pose out_pose;
    abmt::vec3 in_pos = {0,0,0};
    
    void tick();
};

//@node: auto
struct rotate{
    abmt::pose out_pose;
    
    float in_ang;
    abmt::vec3 in_vec = {1,0,0};
    
    void tick();
};

//@node: auto
struct cube{
    abmt::scene out_sc;
    std::shared_ptr<abmt::cuboid> cube;
    
    abmt::vec3 in_size  = {1, 1, 1};
    abmt::col4 in_color = {155, 155, 155, 255};
    
    void init();
    void tick();
};

//@node: auto
struct point3d{
    abmt::scene out_sc;
    std::shared_ptr<abmt::point3d> point;
    
    double in_size  = 1;
    abmt::col4 in_color = {155, 155, 155, 255};
    
    void init();
    void tick();
};

//@node: auto
struct line3d{
    abmt::scene out_sc;
    std::shared_ptr<abmt::line3d> line;
    
    abmt::vec3 in_p1  = {0, 0, 0};
    abmt::vec3 in_p2  = {0, 1, 0};
    abmt::col4 in_color = {155, 155, 155, 255};
    
    void init();
    void tick();
};

//@node: auto
struct model3d{
    abmt::scene out_sc;
    std::shared_ptr<abmt::model> model;
    
    std::string param_file_name = "../data/model.glb";
    double param_scale = 1.0;
    
    void init();
};

//@node: auto
struct spline3d{
    abmt::scene out_sc;
    std::shared_ptr<abmt::spline> spline;
    
    abmt::img in_img;
    double param_scale = 0.01;
    
    void init();
    void tick();
};

//@node: auto
struct grid_xy{
    abmt::scene out_sc;
    double param_step_size = 1.0;
    int param_steps_x = 10;
    int param_steps_y = 10;
    float param_z = -0.001;
    void init();
};

//@node: auto
struct grid_xz{
    abmt::scene out_sc;
    double param_step_size = 1.0;
    int param_steps_x = 10;
    int param_steps_z = 10;
    float param_y = -0.001;
    void init();
};
//@node: auto
struct grid_yz{
    abmt::scene out_sc;
    double param_step_size = 1.0;
    int param_steps_y = 10;
    int param_steps_z = 10;
    float param_x = -0.001;
    void init();
};

//@node: auto
struct axis{
    abmt::scene out_sc;
    double param_len = 1.0;
    void init();
};


} // namespace scene3d

#endif // MATH3D_EXAMPLE_BASIC_3D_H
